/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.resource;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URI;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Optional;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

import nz.org.riskscape.engine.RiskscapeIOException;
import nz.org.riskscape.problem.ResultOrProblems;

/**
 * Resource that is provided by a file.
 */
@RequiredArgsConstructor @EqualsAndHashCode
public class FileResource implements Resource {

  public static FileResource load(URI target) throws ResourceLoadingException {
    if (!target.getScheme().equals("file")) {
      throw new ResourceLoadingException(target, String.format("%s is not a file resource", target));
    }
    Path targetPath = Paths.get(target);
    // TODO check for directory
    if (! targetPath.toFile().exists()) {
      throw new ResourceLoadingException(target, ResourceProblems.get().notFound(target));
    } else if (! targetPath.toFile().canRead()) {
      throw new ResourceLoadingException(target,
          ResourceProblems.get().readAccessDenied(target));
    }
    return new FileResource(targetPath);
  }

  @Getter
  private final Path filePath;

  @Override
  public URI getLocation() {
    return filePath.toUri();
  }

  @Override
  public InputStream getContentStream() throws RiskscapeIOException {
    try {
    return new FileInputStream(filePath.toFile());
    } catch (IOException e) {
      throw new RiskscapeIOException("Could get input stream from resource " + getLocation().toString(), e);
    }
  }

  @Override
  public String toString() {
    return String.format("FileResource(%s)", filePath.toString());
  }

  @Override
  public ResultOrProblems<Path> ensureLocal(Options options, String extension) {
    // NB: what if the extension doesn't match?  Throw an error?
    return ResultOrProblems.of(filePath);
  }

  @Override
  public Optional<Path> getLocal() {
    return Optional.of(filePath);
  }

}
